{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixos-unstable";
    utils.url = "github:numtide/flake-utils";
  };

  outputs = {
    self,
    nixpkgs,
    utils,
  }: let
    out = system: let
      pkgs = nixpkgs.legacyPackages."${system}";
      python = pkgs.python39;
    in {
      devShell = pkgs.mkShell {
        buildInputs = with pkgs; [
          python39Packages.poetry
          libnotify
        ];
      };

      defaultPackage = with pkgs.poetry2nix;
        mkPoetryApplication {
          inherit python;
          projectDir = ./.;
        };

      defaultApp = utils.lib.mkApp {
        drv = self.defaultPackage."${system}";
      };
    };
  in
    with utils.lib; eachSystem defaultSystems out;
}
